<?php
	/*
	参数说明:
		username： 

	*/
	function checkMobileUsername($username){
		if(!$username){//用户名参数为空
			$this->errorMsg(\Zndp\Api\ResponseCode::EMPTY_USERNAME);
		}
		$where = array(
				'UserName'=>$username,
				'RoleId' => ['neq',\Zndp\User\RoleEnum::FARM_OPERATOR],
				);
		$userinfo = MM('uc_user')->where($where)->find();
		if(!$userinfo){//用户名不存在
			$this->errorMsg(\Zndp\Api\ResponseCode::USERNAME_NOT_EXISTS);
		}
		return $userinfo;
	}

	/*
	参数说明:
		channel_number：通道号 

	*/
	function MapChannelNumberToZk($channel_number){
		switch($channel_number){
			case '1' :
			return array(
				'ChNumber' => 7,
				'DisplayName' => '风口左',
				'ChNumberText' => 'column_7',
			);
			break;
			case '2' :
			return array(
				'ChNumber' => 3,
				'DisplayName' => '气温',
				'ChNumberText' => 'column_3',
			);
			break;
			case '3' :
			return array(
				'ChNumber' => 4,
				'DisplayName' => '湿度',
				'ChNumberText' => 'column_4',
			);
			break;
			case '4' :
			return array(
				'ChNumber' => 1,
				'DisplayName' => '光照',
				'ChNumberText' => 'column_1',
			);
			break;
			case '5' :
			return array(
				'ChNumber' => 8,
				'DisplayName' => '风口左',
				'ChNumberText' => 'column_8',
			);
			break;
			default :
		
			break;
		
		}
	}

	/*
	参数说明:
		channel_number：通道号 

	*/
	function MapChannelNumber($channel_number){
		if(!$channel_number){ 
			return false;
		}
		if($channel_number == 1){  //中科光照通道号
			return 4;	//光照1
		}
		if($channel_number == 3){  //中科气温通道号
			return 2;	//气温1
		}
		if($channel_number == 4){  //中科湿度通道号
			return 3;	//湿度1
		}
		if($channel_number == 6){	//中科保温被通道号
			return false;
		}
		if($channel_number == 7){	//中科风口左通道号
			return 1;	//卷膜1左
		}
		if($channel_number == 8){	//中科风口右通道号
			return 5;	//卷膜1右
		}
		return false;
		
	}


